import numpy
from model import *
from triangle import *
from setmask import *
from parameterize import *
from setflowequation import *
from EnumDefinitions import *
from solve import *
from MatlabFuncs import *
from triangle import *
from setmask import *
from parameterize import *
from setflowequation import *
from solve import *

md=triangle(model,'../Exp/Pig.exp',20000.)
md=setmask(md,'../Exp/PigShelves.exp','../Exp/PigIslands.exp')
md=parameterize(md,'../Par/Pig.py')
md.extrude(3,1.)
md=setflowequation(md,'pattyn','all')


# control parameters

md.inversion.iscontrol=1
md.inversion.control_parameters=['FrictionCoefficient']
md.inversion.min_parameters=1*ones(md.mesh.numberofvertices,1)
md.inversion.max_parameters=200*ones(md.mesh.numberofvertices,1)
md.inversion.nsteps=2
md.inversion.cost_functions=[103*ones(md.inversion.nsteps,1)  501*ones(md.inversion.nsteps,1)]
md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,2)
 md.inversion.cost_functions_coefficients(:,2)=2.*10^-7
md.inversion.gradient_scaling=3.*ones(md.inversion.nsteps,1)
md.inversion.maxiter_per_step=2*ones(md.inversion.nsteps,1)
md.inversion.step_threshold=0.99*ones(md.inversion.nsteps,1)
md.inversion.vx_obs=md.initialization.vx
 md.inversion.vy_obs=md.initialization.vy


md.cluster=generic('name',oshostname(),'np',3)
md=solve(md,DiagnosticSolutionEnum())


# Fields and tolerances to track changes

field_names     =['Gradient','Misfits','FrictionCoefficient','Pressure','Vel','Vx','Vy']
field_tolerances=[1e-11,1e-11,1e-11,1e-11,1e-11,1e-11,1e-11,1e-11,1e-11,1e-11]
field_values=[\
	md.results['DiagnosticSolution'][1]['Gradient1'],\
	md.results['DiagnosticSolution'][1]['J'],\
	md.results['DiagnosticSolution'][1]['FrictionCoefficient'],\
	md.results['DiagnosticSolution'][1]['Pressure'],\
	md.results['DiagnosticSolution'][1]['Vel'],\
	md.results['DiagnosticSolution'][1]['Vx'],\
	md.results['DiagnosticSolution'][1]['Vy']
]
